[PATCH bpf v3] selftests/bpf: convert test_xdp_redirect.sh to bash

Subsystems: bpf [general] (safe dynamic programs and tools), bpf [selftests] (test runners & infrastructure), kernel selftest framework, the rest, xdp (express data path)

STALE2002d REVIEWED: 1 (0M)

1 review trailer.

3 messages, 3 authors, 2021-02-11 · open the first message on its own page

[PATCH bpf v3] selftests/bpf: convert test_xdp_redirect.sh to bash

From: Björn Töpel <hidden>
Date: 2021-02-09 07:46:33

From: Björn Töpel <redacted>

The test_xdp_redirect.sh script uses a bash feature, '&>'. On systems,
e.g. Debian, where '/bin/sh' is dash, this will not work as
expected. Use bash in the shebang to get the expected behavior.

Further, using 'set -e' means that the error of a command cannot be
captured without the command being executed with '&&' or '||'. Let us
use '||' to capture the return value of a failed command.

v3: Reintroduced /bin/bash, and kept 'set -e'. (Andrii)
v2: Kept /bin/sh and removed bashisms. (Randy)

Acked-by: William Tu <redacted>
Signed-off-by: Björn Töpel <redacted>
---
 tools/testing/selftests/bpf/test_xdp_redirect.sh | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)
diff --git a/tools/testing/selftests/bpf/test_xdp_redirect.sh b/tools/testing/selftests/bpf/test_xdp_redirect.sh
index dd80f0c84afb..3f85a82f1c89 100755
--- a/tools/testing/selftests/bpf/test_xdp_redirect.sh
+++ b/tools/testing/selftests/bpf/test_xdp_redirect.sh
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # Create 2 namespaces with two veth peers, and
 # forward packets in-between using generic XDP
 #
@@ -43,6 +43,8 @@ cleanup()
 test_xdp_redirect()
 {
 	local xdpmode=$1
+	local ret1=0
+	local ret2=0
 
 	setup
 
@@ -57,10 +59,8 @@ test_xdp_redirect()
 	ip link set dev veth1 $xdpmode obj test_xdp_redirect.o sec redirect_to_222 &> /dev/null
 	ip link set dev veth2 $xdpmode obj test_xdp_redirect.o sec redirect_to_111 &> /dev/null
 
-	ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null
-	local ret1=$?
-	ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null
-	local ret2=$?
+	ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null || ret1=$?
+	ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null || ret2=$?
 
 	if [ $ret1 -eq 0 -a $ret2 -eq 0 ]; then
 		echo "selftests: test_xdp_redirect $xdpmode [PASS]";
base-commit: 6183f4d3a0a2ad230511987c6c362ca43ec0055f
-- 
2.27.0

Re: [PATCH bpf v3] selftests/bpf: convert test_xdp_redirect.sh to bash

From: Andrii Nakryiko <hidden>
Date: 2021-02-10 20:14:48

On Mon, Feb 8, 2021 at 11:45 PM Björn Töpel [off-list ref] wrote:
From: Björn Töpel <redacted>

The test_xdp_redirect.sh script uses a bash feature, '&>'. On systems,
e.g. Debian, where '/bin/sh' is dash, this will not work as
expected. Use bash in the shebang to get the expected behavior.

Further, using 'set -e' means that the error of a command cannot be
captured without the command being executed with '&&' or '||'. Let us
use '||' to capture the return value of a failed command.

v3: Reintroduced /bin/bash, and kept 'set -e'. (Andrii)
v2: Kept /bin/sh and removed bashisms. (Randy)

Acked-by: William Tu <redacted>
Signed-off-by: Björn Töpel <redacted>
---
Not exactly what I had in mind (see below), but it's ok like this as well, so:

Acked-by: Andrii Nakryiko <andrii@kernel.org>

Does it have to go through the bpf tree or bpf-next is fine? And what
about Fixes: tag?

quoted hunk
 tools/testing/selftests/bpf/test_xdp_redirect.sh | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)
diff --git a/tools/testing/selftests/bpf/test_xdp_redirect.sh b/tools/testing/selftests/bpf/test_xdp_redirect.sh
index dd80f0c84afb..3f85a82f1c89 100755
--- a/tools/testing/selftests/bpf/test_xdp_redirect.sh
+++ b/tools/testing/selftests/bpf/test_xdp_redirect.sh
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # Create 2 namespaces with two veth peers, and
 # forward packets in-between using generic XDP
 #
@@ -43,6 +43,8 @@ cleanup()
 test_xdp_redirect()
 {
        local xdpmode=$1
+       local ret1=0
+       local ret2=0

        setup
@@ -57,10 +59,8 @@ test_xdp_redirect()
        ip link set dev veth1 $xdpmode obj test_xdp_redirect.o sec redirect_to_222 &> /dev/null
        ip link set dev veth2 $xdpmode obj test_xdp_redirect.o sec redirect_to_111 &> /dev/null

-       ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null
-       local ret1=$?
-       ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null
-       local ret2=$?
+       ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null || ret1=$?
+       ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null || ret2=$?
You didn't like

if ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null &&
   ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null; then
        echo "selftests: test_xdp_redirect $xdpmode [PASS]"
...

?
        if [ $ret1 -eq 0 -a $ret2 -eq 0 ]; then
                echo "selftests: test_xdp_redirect $xdpmode [PASS]";

base-commit: 6183f4d3a0a2ad230511987c6c362ca43ec0055f
--
2.27.0

Re: [PATCH bpf v3] selftests/bpf: convert test_xdp_redirect.sh to bash

From: Björn Töpel <hidden>
Date: 2021-02-11 08:07:44

On 2021-02-10 21:13, Andrii Nakryiko wrote:
On Mon, Feb 8, 2021 at 11:45 PM Björn Töpel [off-list ref] wrote:
quoted
From: Björn Töpel <redacted>

The test_xdp_redirect.sh script uses a bash feature, '&>'. On systems,
e.g. Debian, where '/bin/sh' is dash, this will not work as
expected. Use bash in the shebang to get the expected behavior.

Further, using 'set -e' means that the error of a command cannot be
captured without the command being executed with '&&' or '||'. Let us
use '||' to capture the return value of a failed command.

v3: Reintroduced /bin/bash, and kept 'set -e'. (Andrii)
v2: Kept /bin/sh and removed bashisms. (Randy)

Acked-by: William Tu <redacted>
Signed-off-by: Björn Töpel <redacted>
---
Not exactly what I had in mind (see below), but it's ok like this as well, so:

Acked-by: Andrii Nakryiko <andrii@kernel.org>

Does it have to go through the bpf tree or bpf-next is fine? And what
about Fixes: tag?

quoted
  tools/testing/selftests/bpf/test_xdp_redirect.sh | 10 +++++-----
  1 file changed, 5 insertions(+), 5 deletions(-)
diff --git a/tools/testing/selftests/bpf/test_xdp_redirect.sh b/tools/testing/selftests/bpf/test_xdp_redirect.sh
index dd80f0c84afb..3f85a82f1c89 100755
--- a/tools/testing/selftests/bpf/test_xdp_redirect.sh
+++ b/tools/testing/selftests/bpf/test_xdp_redirect.sh
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
  # Create 2 namespaces with two veth peers, and
  # forward packets in-between using generic XDP
  #
@@ -43,6 +43,8 @@ cleanup()
  test_xdp_redirect()
  {
         local xdpmode=$1
+       local ret1=0
+       local ret2=0

         setup
@@ -57,10 +59,8 @@ test_xdp_redirect()
         ip link set dev veth1 $xdpmode obj test_xdp_redirect.o sec redirect_to_222 &> /dev/null
         ip link set dev veth2 $xdpmode obj test_xdp_redirect.o sec redirect_to_111 &> /dev/null

-       ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null
-       local ret1=$?
-       ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null
-       local ret2=$?
+       ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null || ret1=$?
+       ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null || ret2=$?
You didn't like

if ip netns exec ns1 ping -c 1 10.1.1.22 &> /dev/null &&
    ip netns exec ns2 ping -c 1 10.1.1.11 &> /dev/null; then
         echo "selftests: test_xdp_redirect $xdpmode [PASS]"
...

?
Ah, yeah that's better. I'll spin a v4 with this and proper fixes-tag. 
Thanks, Andrii!

Björn
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help